# Switching, VLAN, IP-in-IP-Tunneling, VPN
## Switching
> Prozess, der Daten von einem **input Interface (Port)** zu einem **output Interface (Port)** transferiert
> 
> Beruht darauf, dass Sender und Empfänger direkt miteinander verbunden sind
> 
> Zentrale (Switching Factory) muss in der Lage sein, eine Verbindung zwischen den Ports herzustellen


### Switch (Definition)
> Weiterentwicklung einer Bridge, arbeitet ebenfalls auf L2
> 
> verwendet MAC-Adressen zur Zustellung der Daten

#### Bridge vs Switch
> Bridge kann Bandbreite und Performance **im Gesamtnetz** verbessern
> 
> Leitet Daten nur weiter, wenn es von Segment zu Segment ist

> Switch kann Bandbreite und Performance **innerhalb eines Segments** verbessern
> 
> direkte und dedizierte Verbindungen zwischen den Ports


#### Switch-Typen
##### Cut-Through-Switches (CT)
- schnelle Durchleitung, kurze Latenzzeiten
- Puffern von ankommenden Frames bis zum Empfang der MAC-Zieladresse
- **Keine Fehlererkennung, Filtermechanismen**

##### Store-and-Forward-Switches (SF)
- Puffern auch
- können Filtern und Fehler erkennen


#### Managed Switche
##### Managed L2-Switch
- bietet zusätzliche Funktionen an
  - VLAN-Konfiguration
  - Port-Sicherheit
  - Zugriffskontrollen

##### Managed L3-Switch
- Managed L2-Switch + Routing-Fähigkeiten (typischerweise L3)
- Routing
  - kann IP-Pakete zwischen verschiedenen VLANs routen (IP-Adressen-basiert)
  - div. Protokolle werden unterstützt
- Nutzt L3-Infos (IPs, Diensttypen) für bessere QoS
- erweiterte Konfigurationsmöglichkeiten


##### QoS Managed L2 vs Managed L3 Switc
|                              | **Managed L2**                                                                                | **Managed L3**                                                                                                                      |
|------------------------------|-----------------------------------------------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------|
| Datenverkehrsklassifizierung | mittels VLAN IEEE 802.1Q Tagging<br/> Ethernet-Frames enthalten VLAN-Tags, die Prio enthalten | L2, IP-Header, Protokolle, Portnummer, Inhalt von Datenpaketen                                                                      |
| Markierung und Priorisierung | Setzen/Ändern des PCP-Wertes (Prio) im VLAN Tag                                               | Prio im IP-Header<br/>(genauer, da 0-63 nicht 0-7 mögliche Werte)                                                                   |
| Warteschlangenmanagement     | mehrere Hardware-Warteschlangen pro Port<br/>Frames mit hoher Prio werden vorne eingereiht    | mehrere Warteschlangen für ausgehenden Verkehr<br/>je nach Prio einsortiert                                                         |
| Planung (Scheduling)         | Round-Robin oder Weighted Fair Queuing<br/>Prio früher                                        | Weighted-Fair-Queuing, Class-Based WFQ, Low Latency Queuing                                                                         |
| Verkehrsformung und Policing | nur auf fortgeschrittenen Geräten                                                             | Datenflussrate begrenzen (Datenströme können Bandbreite nicht überschreiten)<br/>übermäßiger Datenverkehr wird gedrosselt/verworfen |
| Congestion Management        |                                                                                               | Bei Netzwerküberlastung:<br/>(Weighted) Random Early Detection um Stauungen zu verwalten/verhindern                                 |


## VLAN
> VLANs unterteilen bestehendes, einzelnes, **physisches Netzwerk in mehrere logische Netzwerke**
> 
> VLAN entspricht **einer Broadcast-Domäne**
> 
> können sich **über mehrere Switche hinweg** strecken

### Gruppierungsmöglichkeiten
- Port-basierend
- MAC-basierend
- Netzwerkprotokoll-basierend
- Switching mit Netzwerkadressen (L3 Switching)
  - Information im Header der Netzwerkschicht entscheidet

### Optimierung mit VLANs
> Alles weg und Managed-Layer-3 Switche hin
> 
> "Normale Switche" zu "VLAN-Switchen"

![image_851.png](image_851.png)
![image_852.png](image_852.png)


## IP-in-IP-Tunneling
### Tunnel
![image_853.png](image_853.png)
> (logisch) geschützter Kanal für Datenpakete zwischen Eingang und Ausgang
> 
> IP-Paket in einem weiteren IP-Paket gekapselt:
> äußerer Header adressiert Tunnelenden, sieht aus wie Nutzdaten, 
> bis er vom Tunnelende entpackt wird und kann dann weitergeleitet werden